{
  description = "Base configuration for self-host-playbook";

  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixos-24.11";
    nixpkgs-unstable.url = "github:NixOS/nixpkgs/b62d2a95c72fb068aecd374a7262b37ed92df82b";
  };

  outputs = {
    self,
    nixpkgs,
    nixpkgs-unstable,
  }: {
    nixosModules = {
      default = {
        tier ? "starter",
        jsonConfig ? {},
      }: {
        # Add jsonConfig as an optional argument with a default empty attrset
        config,
        lib,
        pkgs,
        ...
      }: {
        nixpkgs.overlays = [
          (final: _prev: {
            unstable = import nixpkgs-unstable {
              system = final.system;
            };
          })
        ];
        imports = [
          ./modules/core.nix
          (import ./modules/services.nix {
            inherit lib config pkgs;
            tier = tier;
            jsonConfig = jsonConfig; # Pass jsonConfig to services.nix
          })
        ];
      };
    };
  };
}
